﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;

namespace WobbrockLib.Controls
{
	/// <summary>
	/// Provides a panel control whose painting is double-buffered to reduce flicker.
	/// </summary>
	[ToolboxBitmap(typeof(System.Windows.Forms.Panel))]
    public partial class DoubleBufferedPanel : Panel
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public DoubleBufferedPanel()
			: this(null)
        {
            // do nothing
        }

		/// <summary>
		/// Constructor.
		/// </summary>
		/// <param name="container">The container for this control.</param>
		public DoubleBufferedPanel(IContainer container)
		{
			container?.Add(this);
			InitializeComponent();
			this.SetStyle(
				ControlStyles.OptimizedDoubleBuffer |
				ControlStyles.AllPaintingInWmPaint |
				ControlStyles.UserPaint,
				true);
		}
	}
}
