﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;
using WobbrockLib.Extensions;
using WobbrockLib.Windows;
using WobbrockLib.Types;

namespace Test
{
	public partial class ImageForm : Form
	{
		private Bitmap _bmpOriginal;
		private long _time;

		public ImageForm()
		{
			InitializeComponent();
		}

		private void ImageForm_Load(object sender, EventArgs e)
		{
			_bmpOriginal = (Bitmap) picImage.Image;
			this.Location = new Point(100, 100);
			this.Size = new Size(600, 600);
		}

		private void ImageForm_LocationChanged(object sender, EventArgs e)
		{
			lblX.Text = String.Format("Left: {0}", this.Left);
			lblY.Text = String.Format("Top: {0}", this.Top);
			lblS.Text = String.Format("Scaling: {0}", ControlPanelEx.GetDisplayScaling(this.Location));
		}

		private void ImageForm_SizeChanged(object sender, EventArgs e)
		{
			lblW.Text = String.Format("Width: {0}", this.Width);
			lblH.Text = String.Format("Height: {0}", this.Height);
		}

		private void cmdReset_Click(object sender, EventArgs e)
		{
			picImage.Image = _bmpOriginal;
		}

		private void cmdGaussian_Click(object sender, EventArgs e)
		{
			System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;

			_time = TimeEx.NowTicks;
			Bitmap newBmp = DrawingEx.GaussianBlur((Bitmap) picImage.Image, (int) numAmount.Value);
			double elapsed = Math.Round(TimeEx.Ticks2Sec(TimeEx.NowTicks - _time), 3);

			picImage.Image = newBmp;
			lblTime.Text = String.Format("Time: {0}", elapsed);

			System.Windows.Forms.Cursor.Current = Cursors.Default;
			Application.DoEvents();
		}

		private void cmdFastGaussian_Click(object sender, EventArgs e)
		{
			System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;

			_time = TimeEx.NowTicks;
			Bitmap newBmp = DrawingEx.FastGaussianBlur((Bitmap) picImage.Image, (int) numAmount.Value);
			double elapsed = Math.Round(TimeEx.Ticks2Sec(TimeEx.NowTicks - _time), 3);

			picImage.Image = newBmp;
			lblTime.Text = String.Format("Time: {0}", elapsed);

			System.Windows.Forms.Cursor.Current = Cursors.Default;
			Application.DoEvents();
		}

		private void cmdBox_Click(object sender, EventArgs e)
		{
			System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;

			_time = TimeEx.NowTicks;
			Bitmap newBmp = DrawingEx.BoxBlur((Bitmap) picImage.Image, (int) numAmount.Value);
			double elapsed = Math.Round(TimeEx.Ticks2Sec(TimeEx.NowTicks - _time), 3);

			picImage.Image = newBmp;
			lblTime.Text = String.Format("Time: {0}", elapsed);

			System.Windows.Forms.Cursor.Current = Cursors.Default;
			Application.DoEvents();
		}

		private void cmdFastBox_Click(object sender, EventArgs e)
		{
			System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;

			_time = TimeEx.NowTicks;
			Bitmap newBmp = DrawingEx.FastBoxBlur((Bitmap) picImage.Image, (int) numAmount.Value);
			double elapsed = Math.Round(TimeEx.Ticks2Sec(TimeEx.NowTicks - _time), 3);

			picImage.Image = newBmp;
			lblTime.Text = String.Format("Time: {0}", elapsed);

			System.Windows.Forms.Cursor.Current = Cursors.Default;
			Application.DoEvents();
		}

		private void cmdSshot_Click(object sender, EventArgs e)
		{
			//Bitmap bmp = DrawingEx.Screenshot(this.Location);
			Bitmap bmp = DrawingEx.ScrapePixelsFromScreen(this.Location, this.Size, ContentAlignment.TopLeft);

			//bmp.Save(String.Format("C:\\Users\\wobbrock\\Documents\\My Work\\WobbrockLib\\tmp\\{0}.bmp", TimeEx.NowTicks));
			bmp.Save(String.Format("C:\\Users\\wobbrock\\Documents\\My Universities\\UW\\Research\\Software\\WobbrockLib\\tmp\\{0}.bmp", TimeEx.NowTicks));
		}
	}
}
